//: Playground - noun: a place where people can play

import Cocoa

// パズル：ハノイの塔

// お皿の枚数を渡すと、ハノイの塔の手順を示す関数
func hanoi(diskCount n: Int64)  -> [(pickUp: String, putDown: String)]
{
    // 関数の中で関数定義ができる
    func hanoi_internal(diskCount n: Int64, from x:String, to y:String, work z:String) -> [(pickUp: String, putDown: String)]
    {        
        if n != 0
        {
            return hanoi_internal( diskCount:n - 1, from:x, to:z, work:y)
                    + [(pickUp: x, putDown: y)]
                    + hanoi_internal( diskCount:n - 1, from:z, to:y, work:x)        
        }
        else
        {
            return []
        }
    }

    return hanoi_internal(diskCount:n, from:"left", to:"right", work:"center")
}


// ハノイの塔の出力
func printHanoi01(hanoiArray: [(pickUp: String, putDown: String)])
{
    for action in hanoiArray
    {
        print(action)
    }
}

printHanoi01(hanoiArray: hanoi(diskCount:3))


// ハノイの塔の出力その2
func printHanoi02(hanoiArray: [(pickUp: String, putDown: String)])
{
    let theDict: Dictionary<String, String> = ["left":"左側", "center":"中央", "right":"右側"]
    
    for action in hanoiArray
    {
        print("円盤を \(theDict[action.pickUp]!) から \(theDict[action.putDown]!) に移動する")
    }
}

printHanoi02(hanoiArray: hanoi(diskCount:3))
